% Deguang Yu - CIS 601 - Home work #3
% Due: October 4th, 2004
% 
% A program to implement image smoothing using nonlinear filters median, opening, closing
%------------------------------------

clear all;
close all;

io=imread('noise_2.gif');
im=double(io); 

rows=size(io,1);
cols=size(io,2);

i_median=zeros(rows+2,cols+2); 
i_median1=zeros(rows+2,cols+2); 

new_pic_median=zeros(rows,cols); 
new_pic_opening=zeros(rows,cols); 
new_pic_closing=zeros(rows,cols); 

%using median
for i=2:1:rows+1
    for j=2:1:cols+1
        i_median(i,j)=im(i-1,j-1);
    end
end

for i=2:1:rows+1
    for j=2:1:cols+1
        block=i_median(i-1:i+1,j-1:j+1);
        new_pic_median(i-1,j-1)=median(block(:));
    end
end

figure; colormap(gray(256));  image(im); title('input image') %displays image
figure; colormap(gray(256)); image(new_pic_median); title('output image, filtered by median') %displays image

%using opening
for i=2:1:rows+1
    for j=2:1:cols+1
        block=i_median(i-1:i+1,j-1:j+1);
        i_median1(i,j)=max(block(:));
    end
end

for i=2:1:rows+1
    for j=2:1:cols+1
        block=i_median1(i-1:i+1,j-1:j+1);
        new_pic_opening(i-1,j-1)=min(block(:));
    end
end

figure; colormap(gray(256)); image(new_pic_opening); title('output image, filtered by opening') %displays image
%using closing

for i=2:1:rows+1
    for j=2:1:cols+1
        block=i_median(i-1:i+1,j-1:j+1);
        i_median1(i,j)=min(block(:));
    end
end

for i=2:1:rows+1
    for j=2:1:cols+1
        block=i_median1(i-1:i+1,j-1:j+1);
        new_pic_closing(i-1,j-1)=max(block(:));
    end
end

figure; colormap(gray(256)); image(new_pic_closing); title('output image, filtered by closing') %displays image


